Foxit PDF SDK

Public Member Functions | Static Public Attributes | List of all members
FSDK.Field Class Reference

## Public Member Functions
| constructor (document, field_dict)
| Constructor, from field dictionary. More...
| GetAlignment ()
| Get the alignment value. More...
| GetAlternateName ()
| Get alternate name. More...
| GetControl (index)
| Get a form control by index. More...
| GetControl (page, index)
| Get a form control by index, in a specified PDF page. More...
| GetControlCount ()
| Get count of form controls. More...
| GetControlCount (page)
| Get count of form controls in a specified PDF page. More...
| GetDefaultAppearance ()
| Get the default appearance data. More...
| GetDefaultValue ()
| Get default value. More...
| GetDefaultValueObj ()
| Get the PDF object of field's default value. More...
| GetDict ()
| Get the PDF dictionary of current object. More...
| GetFlags ()
| Get field flags. More...
| GetInheritedAttribute (attribute_name)
| Get the PDF object for specified attribute which may be inherited from the ancestor node in the field tree. More...
| GetMappingName ()
| Get mapping name. More...
| GetMaxLength ()
| Get maximum length of the field's text, in characters. More...
| GetName ()
| Get field name. More...
| GetOptions ()
| Get options of list box or combo box. More...
| GetTopVisibleIndex ()
| Get top index of option for scrollable list boxes. More...
| GetType ()
| Get field type. More...
| GetValue ()
| Get value. More...
| GetValueObj ()
| Get the PDF object of field's value. More...
| IsEmpty ()
| Check whether current object is empty or not. More...
| Reset ()
| Reset data in current field to its default value. (Not support signature field) More...
| SetAlignment (alignment)
| Set alignment property of a form, as a document-wide default value. (Not support signature field) More...
| SetAlternateName (alternate_name)
| Set alternate name. (Not support signature field) More...
| SetDefaultAppearance (default_ap)
| Set default appearance data. More...
| SetDefaultValue (value)
| Set default value. More...
| SetFlags (flags)
| Set field flags. More...
| SetMappingName (name)
| Set mapping name. (Not support signature field) More...
| SetMaxLength (max_length)
| Set maximum length of the field's text, in characters. More...
| SetOptions (option_array)
| Set options of list box or combo box. More...
| SetTopVisibleIndex (index)
| Set top index for scrollable list boxes. More...
| SetValue (value)
| Set value. More...

## Static Public Attributes
static | e_FlagButtonNoToggleToOff
| (Only useful for radio button) If set, exactly one radio button must be selected at all times; clicking the currently selected button has no effect. If clear, clicking the selected button deselects it, leaving no button selected.
static | e_FlagButtonRadiosInUnison
| (Only useful for radio button) If set, a group of radio buttons within a radio button field that use the same value for the on state will turn on and off in unison; that is if one is checked, they are all checked. If clear, the buttons are mutually exclusive.
static | e_FlagChoiceCommitOnSelChange
| (Only useful for choice field) If set, the new value is committed as soon as a selection is made with the pointing device; if clear, the new value is not committed until the user exits the field.
static | e_FlagChoiceMultiSelect
| (Only useful for list box) If set, more than one items may be selected simultaneously; if clear, no more than one item at a time may be selected.
static | e_FlagChoiceSort
| (Only useful for choice field) If set, the field's option items should be sorted alphabetically.
static | e_FlagComboEdit
| (Only useful for combo box) If set, the combo box includes an editable text control with a drop-down list, if clear, it includes only a drop-down list.
static | e_FlagNoExport
| if set, the field must not be exported by a submit-form action.
static | e_FlagReadOnly
| Enumeration for form field flags. More...
static | e_FlagRequired
| If set, the field must have a value at the time it is exported by a submit-form action.
static | e_FlagTextComb
| (Only useful for text field) If set, use combs. More...
static | e_FlagTextDoNotScroll
| (Only useful for text field) If set, the field does not scroll (horizontally for single-line fields, vertically for multiple-line fields) to accommodate more text than fits within its annotation rectangle. Once the field is full, no further text is accepted.
static | e_FlagTextFileSelect
| (Only useful for text field) If set, the text entered in the field represents the pathname of a file whose contents are to be submitted as the value of the field.
static | e_FlagTextMultiline
| (Only useful for text field) If set, the text field can contain multiple lines of text; if clear, the field's text is restricted to a single line.
static | e_FlagTextNoSpellCheck
| (Only useful for text field) If set, text entered in the field is not spell-checked.
static | e_FlagTextPassword
| (Only useful for text field) If set, the field is intended for entering a secure password that should not be echoed visibly to the screen. Characters typed from the keyboard should instead be echoed in some unreadable form, such as asterisks or bullet characters. More...
static | e_FlagTextRichText
| (Only useful for text field) If set, the value of this field should be represented as a rich text string.
static | e_TypeCheckBox
| Form field type: check box.
static | e_TypeComboBox
| Form field type: combo box.
static | e_TypeListBox
| Form field type: list box.
static | e_TypePushButton
| Form field type: push button.
static | e_TypeRadioButton
| Form field type: radio button.
static | e_TypeSignature
| Form field type: signature field.
static | e_TypeTextField
| Form field type: text field.
static | e_TypeUnknown
| Enumeration for form field type. More...

## Detailed Description

In a PDF document, form fields appear on any combination of pages and all of them make up a single, global interactive form spanning the entire document. Function FSDK.Form.GetField can use to get a form field from interactive form. This class offers functions to get some information/properties of a form field, reset the form field to its default value, and get form control from form field.
When a form fiels's type is FSDK.Field.e_TypeSignature, the form field object is a signature object in fact.
To access additional actions, please construct an FSDK.AdditionalAction object with Field object.

See also
  FSDK.Form
  FSDK.Signature
  FSDK.AdditionalAction

## Member Function Documentation

## ◆ constructor()

FSDK.Field.constructor | ( | document | ,
|  | field_dict |
| ) |  |

Constructor, from field dictionary.

Parameters

  [in] | document | A valid PDF document.
  [in] | field_dict | A PDF dictionary which represents a form field. It should belong to the PDF document specified by parameter document;

## ◆ GetAlignment()

FSDK.Field.GetAlignment | ( |  | ) |

Get the alignment value.

Alignment is a property for variable text and it is only useful for text field, list box and combo box, which may contain variable text as their content.
If a text field or list box has its own alignment value, the document-wide default alignment value will be ignored; otherwise, the document-wide default alignment value will be used for the text field or list box.

Returns
  The alignment value. Please refer to values starting from FSDK.e_AlignmentLeft and this would be one of these values.

## ◆ GetAlternateName()

FSDK.Field.GetAlternateName | ( |  | ) |

Get alternate name.

An alternate field name to be used in place of the actual field name wherever the field must be identified in the user interface (such as in error or status messages referring to the field). This text is also useful when extracting the document's contents in support of accessibility to users with disabilities or for other purposes.

Returns
  The alternate name.

## ◆ GetControl() [1/2]

FSDK.Field.GetControl | ( | index |  | ) |

Get a form control by index.

Parameters

  [in] | index | Form control index. Valid range: from 0 to (count-1). count is returned by function FSDK.Field.GetControlCount.

Returns
  A form control object.

## ◆ GetControl() [2/2]

FSDK.Field.GetControl | ( | page | ,
|  | index |
| ) |  |

Get a form control by index, in a specified PDF page.

Parameters

  [in] | page | A valid PDF page object. It should be in the same document as current form field.
  [in] | index | Form control index. Valid range: from 0 to (count-1). count is returned by function FSDK.Field.GetControlCount with same parameter page.

Returns
  form control object.

## ◆ GetControlCount() [1/2]

FSDK.Field.GetControlCount | ( |  | ) |

Get count of form controls.

Returns
  The count of the form controls.

## ◆ GetControlCount() [2/2]

FSDK.Field.GetControlCount | ( | page |  | ) |

Get count of form controls in a specified PDF page.

Parameters

  [in] | page | A valid PDF page object. It should be in the same document as current form field.

Returns
  The count of the form controls in the specified PDF page.

## ◆ GetDefaultAppearance()

FSDK.Field.GetDefaultAppearance | ( |  | ) |

Get the default appearance data.

Returns
  The default appearance data.

## ◆ GetDefaultValue()

FSDK.Field.GetDefaultValue | ( |  | ) |

Get default value.

Applicable for all fields except push button.

Returns
  Default value string. For field types that are not applicable, an empty string will be returned.

## ◆ GetDefaultValueObj()

FSDK.Field.GetDefaultValueObj | ( |  | ) |

Get the PDF object of field's default value.

The format of field's default value varies depending on the field type. For more details, please refer to "TABLE 8.69 Entries common to all field dictionaries" in <PDF reference 1.7> P676.

Returns
  A PDF object. If there is no "DV" entry or any error occurs, this function will return null.

## ◆ GetDict()

FSDK.Field.GetDict | ( |  | ) |

Get the PDF dictionary of current object.

Returns
  The PDF dictionary of current object. If there is any error, the function will return null.

## ◆ GetFlags()

FSDK.Field.GetFlags | ( |  | ) |

Get field flags.

Field flags specifies various characteristics of a form field.

Returns
  Form field flags. Please refer to values starting from FSDK.Field.e_FlagReadOnly and this would be one or a combination of these values.

## ◆ GetInheritedAttribute()

FSDK.Field.GetInheritedAttribute | ( | attribute_name |  | ) |

Get the PDF object for specified attribute which may be inherited from the ancestor node in the field tree.

Some of the field attributes are designated as inheritable, such as "Ff", "V", "DV", and so on. Please refer to "TABLE 8.69 Entries common to all field dictionaries" in <PDF Reference 1.7> P675. If there is no entry which is specified by attribute_name or any error occurs, this function will return null.

Parameters

  [in] | attribute_name | The name of attribute to be found.

Returns
  A PDF object. If not found, this function will return null.

## ◆ GetMappingName()

FSDK.Field.GetMappingName | ( |  | ) |

Get mapping name.

Mapping name is to be used when exporting interactive form field data from the document.

Returns
  The mapping name.

## ◆ GetMaxLength()

FSDK.Field.GetMaxLength | ( |  | ) |

Get maximum length of the field's text, in characters.

Applicable for text fields. For field types that are not applicable, this function will return 0.

Returns
  The maximum length of the field's text.

## ◆ GetName()

FSDK.Field.GetName | ( |  | ) |

Get field name.

Returns
  Field name string.

## ◆ GetOptions()

FSDK.Field.GetOptions | ( |  | ) |

Get options of list box or combo box.

Applicable for list box and combo box. For field types that are not applicable, this function will return an empty array.

Returns
  An array that contains the options.

## ◆ GetTopVisibleIndex()

FSDK.Field.GetTopVisibleIndex | ( |  | ) |

Get top index of option for scrollable list boxes.

Applicable for list box. For field types that are not applicable, this function will return 0.
Top index of option is the index of the first option visible in the list.

Returns
  The index of first item which is in visible scope of list box.

## ◆ GetType()

FSDK.Field.GetType | ( |  | ) |

Get field type.

Returns
  Form field type. Please refer to values starting from FSDK.Field.e_TypeUnknown and this would be one of these values.

## ◆ GetValue()

FSDK.Field.GetValue | ( |  | ) |

Get value.

Applicable for all fields except push button. For field types that are not applicable, an empty string will be returned. For check box and radio box, this function will return the appearance state value.

Returns
  Value string. Specially, when current field is a list box field with multiple values, only the first value would be returned.

## ◆ GetValueObj()

FSDK.Field.GetValueObj | ( |  | ) |

Get the PDF object of field's value.

The format of field's value varies depending on the field type. For more details, please refer to "TABLE 8.69 Entries common to all field dictionaries" in <PDF reference 1.7> P676.

Returns
  A PDF object. If there is no "V" entry or any error occurs, this function will return null.

## ◆ IsEmpty()

FSDK.Field.IsEmpty | ( |  | ) |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ Reset()

FSDK.Field.Reset | ( |  | ) |

Reset data in current field to its default value. (Not support signature field)

Returns
  true means success, while false means current form field is a signature field or failure.

## ◆ SetAlignment()

FSDK.Field.SetAlignment | ( | alignment |  | ) |

Set alignment property of a form, as a document-wide default value. (Not support signature field)

Alignment is a property for variable text and it is only useful for text field, list box and combo box, which may contain variable text as their content.
If a text field or list box has its own alignment value, the document-wide default alignment value will be ignored; otherwise, the document-wide default alignment value will be used for the text field or list box.
If current form field is a signature field, this function will do nothing.

Parameters

  [in] | alignment | The new default alignment type of variable text. Please refer to values starting from FSDK.e_AlignmentLeft and this should be one of these values. If other values is used to set, FSDK.e_AlignmentLeft will be used by default.

Returns
  None.

## ◆ SetAlternateName()

FSDK.Field.SetAlternateName | ( | alternate_name |  | ) |

Set alternate name. (Not support signature field)

An alternate field name is to be used in place of the actual field name wherever the field must be identified in the user interface (such as in error or status messages referring to the field). This text is also useful when extracting the document's contents in support of accessibility to users with disabilities or for other purposes.
If current form field is a signature field, this function will do nothing.

Parameters

  [in] | alternate_name | A new alternate name string. It should not be an empty string.

Returns
  None.

## ◆ SetDefaultAppearance()

FSDK.Field.SetDefaultAppearance | ( | default_ap |  | ) |

Set default appearance data.

Parameters

  [in] | default_ap | The new default appearance. flags of input data can be used to decide which information is/are to be updated with the new data; for those no updated data, they will keep to use old data. If text_size of input default appearance data is 0, that means the text size should be calculated automatically.

Returns
  None.

## ◆ SetDefaultValue()

FSDK.Field.SetDefaultValue | ( | value |  | ) |

Set default value.

Applicable for all fields except push button. For field types that are not applicable, this function will do nothing.

Parameters

  [in] | value | New default value string. It should not be an empty string.

Returns
  None.

## ◆ SetFlags()

FSDK.Field.SetFlags | ( | flags |  | ) |

Set field flags.

Field flags specifies various characteristics of a form field.

Parameters

  [in] | flags | New form field flags. Please refer to values starting from FSDK.Field.e_FlagReadOnly and this should be one or a combination of these values.

Returns
  None.

## ◆ SetMappingName()

FSDK.Field.SetMappingName | ( | name |  | ) |

Set mapping name. (Not support signature field)

Mapping name is to be used when exporting interactive form field data from the document. If current form field is a signature field, this function will do nothing.

Parameters

  [in] | name | New mapping name string.It should not be an empty string.

Returns
  None.

## ◆ SetMaxLength()

FSDK.Field.SetMaxLength | ( | max_length |  | ) |

Set maximum length of the field's text, in characters.

Applicable for text fields. For field types that are not applicable, this function will do nothing.

Parameters

  [in] | max_length | New maximum length of the field's text. It should be non-negative.

Returns
  None.

## ◆ SetOptions()

FSDK.Field.SetOptions | ( | option_array |  | ) |

Set options of list box or combo box.

Applicable for list box and combo box. For field types that are not applicable, this function will do nothing.

Parameters

  [in] | option_array | An array of options which is to be set to list box or combo box.

Returns
  None.

## ◆ SetTopVisibleIndex()

FSDK.Field.SetTopVisibleIndex | ( | index |  | ) |

Set top index for scrollable list boxes.

Applicable for list box. For field types that are not applicable, this function will do nothing.
Top index of option is the index of the first option visible in the list.

Parameters

  [in] | index | The index of the first option visible in the list.

Returns
  None.

## ◆ SetValue()

FSDK.Field.SetValue | ( | value |  | ) |

Set value.

Applicable for all fields except push button. For field types that are not applicable, this function will do nothing.
Specially, for combo box and text field, when setting value successfully, this function will also trigger related calculation and formatting events and update the appearance of the field.

Parameters

  [in] | value | New value string. Specially, when current field is a list box field, this parameter can contain multiple values: When to set multiple values, each value should be wrapped by "()". For example, "(ABC)(CCC)" means to set 2 value "ABC" and "CCC". If a value contains "()", or "\" as its content, please add an additional "\" as an escape character just in front of each character of "()" or "\". For example: "ABC" means to set the value "ABC". "(ABC)" means to set the value "ABC". "(ABC" means to set the value "(ABC". "(\\(ABC\\)\\(BBB\\)\\(CCC\\))" means to set the value "(ABC)(BBB)(CCC)". "456\\\\" means to set the value "456\". "(\\(ABC\\))" means to set the value "(ABC)".

Returns
  None.

## Member Data Documentation

## ◆ e_FlagReadOnly

FSDK.Field.e_FlagReadOnly
| static

Enumeration for form field flags.

Values of this enumeration can be used alone or in a combination.

If set, the user may not change the value of the field. Any associated widget annotations will not interact with the user; that is, they will not respond to mouse clicks or change their appearance in response to mouse motions. This flag is useful for fields whose values are computed or imported from a database.

## ◆ e_FlagTextComb

FSDK.Field.e_FlagTextComb
| static

(Only useful for text field) If set, use combs.

If set, the field is automatically divided into as many equally spaced positions, or combs, as the value of maximum length of a field's text, and the text is laid out into those combs.

## ◆ e_FlagTextPassword

FSDK.Field.e_FlagTextPassword
| static

(Only useful for text field) If set, the field is intended for entering a secure password that should not be echoed visibly to the screen. Characters typed from the keyboard should instead be echoed in some unreadable form, such as asterisks or bullet characters.

Note
  To protect password confidentiality, viewer applications should never store the value of the text field in the PDF file if this flag is set.

## ◆ e_TypeUnknown

FSDK.Field.e_TypeUnknown
| static

Enumeration for form field type.

Values of this enumeration should be used alone.

Form field type: unknown.